*************************************************************************
*  FTP Services for Visual Foxpro 5.0+                                  *
*  Written by: Robert Abram                                             *
*  Date: Sept 1998                                                      *
*                                                                       *
*  Revision 2.0                                                         *
*                                                                       *
*  Proxy Support                                                        *
*  Paul Culbertson                                                      *
*  http://www.foxite.com/archives/progress_bar_for_ftps_0000013728.htm  *
*                                                                       *
*                                                                       *
*  Revision 1.1a                                                        *
*                                                                       *
*  wininet.dll needs to be in the windows/system                        *
*  directory.                                                           *
*                                                                       *
*  Updated 3/16/99 - Changed Date Usage to comply with                  *
*                    Strict Date handling.                              *
*														                *
*  Added 3/16/99 Functions - AutoDialInternet                           *
*                            AutoDialHangUp                             *
*                            DialInternet                               *
*                            DialHangUp                                 *
*                            GetConnectedState                          *
*                            GoOnline                                   *
*************************************************************************

#INCLUDE "FTP.h"

****************************************************
* Class Ftp_Service                                *
****************************************************
DEFINE CLASS ftp_Service AS custom
   PROTECTED lDLL_Loaded

   cIPAddress 	        = ""
   cUserName           = ""
   cPassword           = ""
   cPort				= "21"     && Default FTP PORT
		
   nInet_Handle 		= 0
   nConnect_Handle 	= 0
   lDLL_Loaded 		= .F.
   nResult_Code		= 0
   nExtended_Result    = 0
   cExtended_Message   = ""
   cCurrentDir			= ""
		
   nCachingType        = INTERNET_FLAG_DONT_CACHE
		
   cAgent 				= "Visual FoxPro" + cNULL

   nFlags             = INTERNET_FLAG_PASSIVE && Default pasive mode
   lMultiOperations  = .T.
   cStartupFolder    = ""

   cProxyProtocol=""  && Protocol for proxy
   cProxyHost=""      && Proxyhost
   cProxyport=""      && ProxyPort
   lUseProxy = .F.
 
				
   ****************************************************
   PROTECTED PROCEDURE Init
*!*	<pdm>
*!*	<descr></descr>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   	  IF _DOS OR _UNIX OR _MAC
         RETURN .F.
      ENDIF
   ENDPROC	
	
   ****************************************************
   PROTECTED PROCEDURE LoadAPIFuncs
      * Variables need for defines
      LOCAL lpcAgent, nAccessType, lpcProxyName, lpcProxyBypass, nFlags,;
            nInet_Handle, nConnect_Handle, lpcServer, nPort, lpcUserName,;
            lpcPassword, nService, nContext, nMax_Path,;
            lpcDirectory, lpcFileName, lpcSearchStr, lpcWIN32_FIND_DATA,;
            lpcRemoteFile, lpcNewFile, nFailIfExists, nAttributes,;
            nError, lpcBuffer, nHandle, lpcDialUp

*!*	<pdm>
*!*	<remarks>Load basic API functions</remarks>
*!*	<seealso>
*!*	 <see loca="" class="FTP_SERVICE" pem="AutoDialInternet">FTP_SERVICE::AutoDialInternet()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="DialInternetDialHangUp">FTP_SERVICE::DialInternetDialHangUp()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="GetConnectedState">FTP_SERVICE::GetConnectedState()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="GoOnline">FTP_SERVICE::GoOnline()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="OpenInternet">FTP_SERVICE::OpenInternet()</see>
*!*	</seealso>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm>   
		   

      * Check to see if We have already declared functions and loaded the DLL
      IF This.lDLL_Loaded  
         RETURN ERROR_SUCCESS
      ENDIF
		   	
      * Declare a Kernel32 Functions
      DECLARE Integer GetLastError IN Kernel32

      DECLARE Integer FileTimeToSystemTime IN Kernel32 ;
              String @lpcBuffer, String @lpcBuffer
		   
      * Declare DLL functions used by Program
      DECLARE Integer InternetAutodial IN WinInet ;
              Integer nAccessType, Integer nHandle
		   		
      DECLARE Integer InternetAutodialHangup IN WinInet ;
              Integer nFlags
		   			
      DECLARE Integer InternetDial IN WinInet ;
              Integer nHandle, String @lpcDialUp, Integer nAccessType, Integer @nConnect_Handle, ;
              Integer nFlags
		   	
      DECLARE Integer InternetHangUp IN WinInet ;
              Integer nConnect_Handle, Integer nFlags
		   			
      DECLARE Integer InternetGetConnectedState IN WinInet ;
              Integer @nContext, Integer nFlags
		   			
      DECLARE Integer InternetGoOnline IN WinInet ;
              String @lpcURL, Integer nHandle, Integer nFlags
		   			
      DECLARE Integer InternetOpen IN WinInet ;
              String @lpcAgent, Integer nAccessType, String @lpcProxyName, ;
              String @lpcProxyBypass, Integer nFlags
		   			
      DECLARE Integer InternetConnect IN WinInet ;
              Integer nInet_Handle, String @lpcServer, Short nPort, String @lpcUserName, ;
              String @lpcPassword, Integer nService, Integer nFlags, Integer nContext

      DECLARE Integer InternetCloseHandle IN WinInet ;
              Integer nConnect_Handle
		   			
      * FTP Functions
      DECLARE Integer FtpCreateDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory
		   			
      DECLARE Integer FtpDeleteFile IN WinInet ;
              Integer nConnect_Handle, String @lpcFileName
		   	
      DECLARE Integer FtpFindFirstFile IN WinInet ;
              Integer nConnect_Handle, String @lpcSearchStr, String @lpcWIN32_FIND_DATA, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer InternetFindNextFile IN WinInet ;
              Integer nConnect_Handle, String @lpcWIN32_FIND_DATA
		   			
      DECLARE Integer FtpGetCurrentDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory, Integer @nMax_Path
		   
      DECLARE Integer FtpGetFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, String @lpcNewFile, ;
              Integer nFailIfExists, Integer nAttributes, Integer nFlags, ;
              Integer nContext
		   			
      DECLARE Integer FtpOpenFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, Integer nAccessType, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer FtpPutFile IN WinInet ;
              Integer nConnect_Handle, String @lpcNewFile, String @lpcRemoteFile, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer FtpRemoveDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory
		   			
      DECLARE Integer FtpRenameFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, String @lpcNewFile
		   			
      DECLARE Integer FtpSetCurrentDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory
		   			
      DECLARE Integer InternetGetLastResponseInfo IN WinInet ;
              Integer @nError, String @lpcBuffer, Integer @nMax_Path

      DECLARE Integer FtpCommand IN WinInet ;
              Integer hConnect, Integer fExpectResponse,;
              Integer dwFlags, STRING @ lpszCommand,;
              Integer dwContext, Integer @ phFtpCommand


      DECLARE INTEGER InternetWriteFile IN WinInet ;
              INTEGER hFile, STRING @ lpBuffer,;
              INTEGER dwNumberOfBytesToWrite, INTEGER @ lpdwNumberOfBytesWritten

      DECLARE INTEGER InternetReadFile IN WinInet ;
              INTEGER hFile, STRING @ lpBuffer,;
              INTEGER dwNumberOfBytesToWrite, INTEGER @ lpdwNumberOfBytesWritten


      This.lDLL_Loaded = .T.
		   	
      RETURN ERROR_SUCCESS	
		   		
   ENDPROC
		
   ****************************************************
   PROCEDURE AutoDialInternet(lnType)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnType" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type="Boolean">The return value is <expr>.T.</expr> if value type is base or <expr>.F.</expr> is not.
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialInternet">FTP_SERVICE::BeforeAutoDialInternet()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="AfterAutoDialInternet">FTP_SERVICE::AfterAutoDialInternet()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialHangUp">FTP_SERVICE::BeforeAutoDialHangUp()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="AfterAutoDialHangUp">FTP_SERVICE::AfterAutoDialHangUp()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*	 <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm>  


      LOCAL lnHWNDHandle, fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
 	     RETURN .F.
      ENDIF	
		   	  
      IF TYPE(lnType) != "N" 
         RETURN .F.
      ENDIF
		   	  
      =This.BeforeAutoDialInternet(lnType)
      lnHWNDHandle = 0	  		
      fResult = InternetAutodial(lnType, lnHWNDHandle)
      =This.GetExtendedError()
      =This.AfterAutoDialInternet(lnType,fResult)
      RETURN fResult # 0 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeAutoDialInternet(lnType)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnType" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialInternet">FTP_SERVICE::AfterAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialInternet">FTP_SERVICE::AutoDialInternet()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm>   
   ENDPROC

   ****************************************************
   PROCEDURE AfterAutoDialInternet(lnType,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnType" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialInternet">FTP_SERVICE::BeforeAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialInternet">FTP_SERVICE::AutoDialInternet()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC



   ****************************************************
   PROCEDURE AutoDialHangUp
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialHangUp">FTP_SERVICE::BeforeAutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialHangUp">FTP_SERVICE::AfterAutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialInternet">FTP_SERVICE::AutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialInternet">FTP_SERVICE::BeforeAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialInternet">FTP_SERVICE::AfterAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF	
	  		
      =This.BeforeAutoHangUp()
      fResult = InternetAutoDialHangUp(0)
      This.GetExtendedError()
      =This.AfterAutoHangUp(fResult)
	  		  
      RETURN fResult # 0 
   ENDPROC
	  		  
   ****************************************************
   PROCEDURE BeforeAutoHangUp()
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialHangUp">FTP_SERVICE::AfterAutoDialHangUp()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterAutoHangUp(fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialHangUp">FTP_SERVICE::BeforeAutoDialHangUp()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
	  
   ****************************************************	
   PROCEDURE DialInternet(lcDialUpName, lnFlag)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDialUpName" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lnFlag" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeDialInternet">FTP_SERVICE::BeforeDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterDialInternet">FTP_SERVICE::AfterDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DialHangUp">FTP_SERVICE::DialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeDialHangUp">FTP_SERVICE::BeforeDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterDialHangUp">FTP_SERVICE::AfterDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult, lnConnectionID, lnHWNDHandle
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
  	  		
      STORE 0 TO lnConnectionID,lnHWNDHandle
  	  		    	  		    	  		  
      IF TYPE("lcDialUpName") != "C" OR ;
         TYPE("lnFlag") != "N"
         RETURN -1
      ENDIF
  	  		
      IF LEN(ALLTRIM(lcDialUpName)) = 0 
         RETURN -1
      ENDIF
  	  		  
      lcDialUpName = lcDialUpName + cNULL
      =This.BeforeDialInternet(lcDialUpName, lnFlag)
      fResult = InternetDial(lnHWNDHandle, @lcDialUpName, lnFlag, @lnConnectionID, 0)
      =This.GetExtendedError()
      =This.AfterDialInternet(lcDialUpName, lnFlag,lnConnectionID,fResult)
      RETURN lnConnectionID
   ENDPROC  

   ****************************************************
   PROCEDURE BeforeDialInternet(lcDialUpName, lnFlag)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDialUpName" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lnFlag" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="DialInternet">FTP_SERVICE::DialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterDialInternet">FTP_SERVICE::AfterDialInternet()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterDialInternet(lcDialUpName, lnFlag,lnConnectionID,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDialUpName" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lnFlag" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lnConnectionID" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeDialInternet">FTP_SERVICE::BeforeDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DialInternet">FTP_SERVICE::DialInternet()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC


   ****************************************************
   PROCEDURE DialHangUp(lnConnectionID)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnConnectionID" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialHangUp">FTP_SERVICE::BeforeAutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialHangUp">FTP_SERVICE::AfterAutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialInternet">FTP_SERVICE::AutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialInternet">FTP_SERVICE::BeforeAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialInternet">FTP_SERVICE::AfterAutoDialInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
		   	  
      IF TYPE("lnConnectionID") != "N"
        	RETURN .F.
      ENDIF
		   	  
      =This.BeforeDialHangUp(lnConnectionID)
      fResult = InternetHangUp(@lnConnectionID, 0)
      This.GetExtendedError()
      =This.AfterDialHangUp(lnConnectionID,fResult)
      RETURN fResult # 0 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeDialHangUp(lnConnectionID)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnConnectionID" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterAutoDialHangUp">FTP_SERVICE::AfterAutoDialHangUp()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterDialHangUp(lnConnectionID,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnConnectionID" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="AutoDialHangUp">FTP_SERVICE::AutoDialHangUp()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeAutoDialHangUp">FTP_SERVICE::BeforeAutoDialHangUp()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

	    
	    
   ****************************************************
   PROCEDURE GetConnectedState
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*   <retval type="Number">The return value is connected state of the local system.
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetConnectedState">FTP_SERVICE::BeforeGetConnectedState()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetConnectedState">FTP_SERVICE::AfterGetConnectedState()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult, lnConnectionState
			
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
			
      lnConnectionState = 0
		
      =This.BeforeGetConnectedState()
      fResult = InternetGetConnectedState(@lnConnectionState, 0)
      =This.GetExtendedError()
      =This.AfterGetConnectedState(fResult)
      RETURN IIF(fResult = 0,-1,lnConnectionState)
   ENDPROC


   ****************************************************
   PROCEDURE BeforeGetConnectedState()
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetConnectedState">FTP_SERVICE::GetConnectedState()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetConnectedState">FTP_SERVICE::AfterGetConnectedState()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetConnectedState(fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetConnectedState">FTP_SERVICE::GetConnectedState()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetConnectedState">FTP_SERVICE::BeforeGetConnectedState()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
		
			  
   ****************************************************	
   PROCEDURE GoOnline(lcURL)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcURL" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGoOnline">FTP_SERVICE::BeforeGoOnline()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGoOnline">FTP_SERVICE::AfterGoOnline()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lnHWNDHandle, fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
		   	  
      IF TYPE("lcURL") != "C"
         RETURN .F.
      ENDIF
	  			
      lcURL = lcURL + cNULL
      lnHWNDHandle = 0
      =This.BeforeGoOnline(lcURL)
      fResult = InternetGoOnline(@lcURL, lnHWNDHandle, 0)
      =This.GetExtendedError()
      =This.AfterGoOnline(lcURL,fResult)
      RETURN fResult # 0 
   ENDPROC	


   ****************************************************
   PROCEDURE BeforeGoOnline(lcURL)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcURL" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GoOnline">FTP_SERVICE::GoOnline()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGoOnline">FTP_SERVICE::AfterGoOnline()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterGoOnline(lcURL,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcURL" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GoOnline">FTP_SERVICE::GoOnline()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGoOnline">FTP_SERVICE::BeforeGoOnline()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

		
   ****************************************************
   PROCEDURE OpenInternet(lcUserName, lcPassword, lcIPAddress, lcPort)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcUserName" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcPassword" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcIPAddress" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcPort" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*   <retval type="Boolean">The return value is <expr>.T.</expr> if is connected to internet or <expr>.F.</expr> is not.
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="LoadAPIFuncs">FTP_SERVICE::LoadAPIFuncs()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="OpenFTPConnection">FTP_SERVICE::OpenFTPConnection()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CloseFTPConnection">FTP_SERVICE::CloseFTPConnection()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CloseInternet>FTP_SERVICE::CloseInternet()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lnPCount, fResult,lnConnectHandle,liAccessType,lcProxyBypass,lcProxyName
		   
      * Check Passed Parameters
      lnPCount = PCOUNT()
		   		   
      IF lnPCount <> 4
         This.nResult_Code = ERROR_INTERNET_BAD_OPTION_LENGTH
         RETURN .F.
      ENDIF
		   	
      * Make sure parameters are of the correct type
      IF (TYPE("lcUserName") != "C") OR ;
         (TYPE("lcPassword") != "C") OR ;
         (TYPE("lcIPAddress") != "C") OR ;
         (TYPE("lcPort") != "C")
         This.nResult_Code = ERROR_INVALID_PARAMETER
         RETURN .F.
      ENDIF
		   	
      * Check Parameter Values
      IF EMPTY(lcUserName) OR EMPTY(lcPassword) OR EMPTY(lcIPAddress)
         This.nResult_Code = ERROR_INTERNET_BAD_OPTION_LENGTH            
         RETURN .F.
      ENDIF
		   	
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF
		   	
		   	
      * Open Handle to Internet
      * Set Parameters
      This.cUserName = lcUserName + cNULL           && Store FTP Connection information
      This.cPassword = lcPassword + cNULL
      This.cIPAddress = lcIPAddress + cNULL
      This.cPort = lcPort


      IF EMPTY(This.cProxyHost) OR ISNULL(This.cProxyHost)
         lcProxyName = .NULL.
         liAccessType=INTERNET_OPEN_TYPE_DIRECT
         This.lUseProxy = .F.
         lcProxyBypass=.NULL.
      ELSE
         *"ftp=ftp://ftp_proxy_name:21", 
         lcProxyName = This.cProxyProtocol+"="+This.cProxyProtocol+"://" + This.cProxyHost + ":" + ALLTRIM(This.cProxyport) + cNULL
         liAccessType=INTERNET_OPEN_TYPE_PROXY
         This.lUseProxy = .T.
         lcProxyBypass=This.cIPAddress
      ENDIF
		    		    	   		    		   
      This.nInet_Handle = InternetOpen((This.cAgent), INTERNET_OPEN_TYPE_DIRECT, @lcProxyName, @lcProxyBypass, 0)
      This.GetExtendedError()
		   	
		   	
      * Unable to Get a Connection into the Internet
      IF This.nInet_Handle = 0
         This.CloseFtpConnection()
         RETURN .F.
      ENDIF
		   
	
      * This Opens the FTP site and Gets the Current Directory.  The handle to the FTP site is opened
      * and closed for each call to any function.	
      * Open FTP Site 
      fResult=This.OpenFtpConnection(This.cStartupFolder)
      =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
      RETURN fResult
   ENDPROC

		
   ****************************************************
   PROCEDURE CloseInternet
*!*   <pdm>
*!*   <!-- <descr></descr> -->
*!*   <retval type=""></retval>
*!*   <remarks></remarks>
*!*   <example></example>
*!*   <seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="OpenInternet>FTP_SERVICE::OpenInternet()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="OpenFTPConnection">FTP_SERVICE::OpenFTPConnection()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CloseFTPConnection">FTP_SERVICE::CloseFTPConnection()</see>
*!*   </seealso>
*!*   <appliesto toref="0" toalso="0" />
*!*   <comment>
*!*   </comment>
*!*   <copyright>&copy;24.11.2005 MJ</copyright>
*!*   </pdm>
 
      * Handles have a Hierarchy.  Closing the Top Handle will close all child handles also.
      * (really?)
      IF This.nInet_Handle != 0
         InternetCloseHandle(This.nInet_Handle)
         This.nInet_Handle = 0
         This.CloseFtpConnection()
      ENDIF
   ENDPROC
      


		
   ****************************************************
   PROCEDURE OpenFtpConnection(lcCurrentFolder)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcCurrentFolder" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*   <retval type="Boolean">The return value is <expr>.T.</expr> if is connected to internet or <expr>.F.</expr> is not.
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetExtendedError">FTP_SERVICE::GetExtendedError()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CloseFTPConnection">FTP_SERVICE::CloseFTPConnection()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CloseInternet>FTP_SERVICE::CloseInternet()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>


*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL nHandle, lnConnect_Handle
      IF This.nConnect_Handle>0 AND .T. && is Valid??
         RETURN .T.
      ENDIF
      * Open FTP Site 
      lnConnect_Handle = InternetConnect(This.nInet_Handle, (This.cIPAddress), VAL(This.cPort), ;
                        (This.cUserName), (This.cPassword), INTERNET_SERVICE_FTP, This.nFlags, 0)
      This.GetExtendedError()
      IF lnConnect_Handle = 0
         RETURN .F.
      ENDIF

      IF PCOUNT()=0 OR EMPTY(lcCurrentFolder)
         lcCurrentFolder = SPACE(MAX_PATH)      
         fResult = FtpGetCurrentDirectory(lnConnect_Handle, @lcCurrentFolder, MAX_PATH)
         This.GetExtendedError()
                  
         IF fResult != 0
            This.cCurrentDir = lcTempDir
         ENDIF
      ELSE
         lcCurrentFolder=This.cCurrentDir
         fResult = FtpSetCurrentDirectory(lnConnect_Handle, @lcCurrentFolder)
      ENDIF

      IF fResult = 1
         This.nConnect_Handle = lnConnect_Handle
         RETURN .T.
      ELSE
         This.GetExtendedError()     && Only Get extended Error information when there is an error
         RETURN .F.
      ENDIF
   ENDPROC
		
   ****************************************************
   PROCEDURE CloseFtpConnection
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="OpenFTPConnection">FTP_SERVICE::OpenFTPConnection()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>

*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      IF This.nConnect_Handle != 0
         =InternetCloseHandle(This.nConnect_Handle)
      ENDIF
	    	
      This.nConnect_Handle = 0
      RETURN
   ENDPROC
	    
		
   ****************************************************
   PROCEDURE SetCachingMethod(nCacheType)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="nCacheType" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
		
      * only change caching type if we have a valid new cache type
      DO CASE 		  	
         CASE nCacheType = INTERNET_FLAG_DONT_CACHE
              This.nCachingType = INTERNET_FLAG_DONT_CACHE
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_HYPERLINK
              This.nCachingType = INTERNET_FLAG_HYPERLINK
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_MAKE_PERSISTENT
              This.nCachingType = INTERNET_FLAG_MAKE_PERSISTENT
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_MUST_CACHE_REQUEST
              This.nCachingType = INTERNET_FLAG_MUST_CACHE_REQUEST
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_RELOAD
              This.nCachingType = INTERNET_FLAG_RELOAD
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_NO_CACHE_WRITE
              This.nCachingType = INTERNET_FLAG_NO_CACHE_WRITE
              fResult = .T.

         CASE nCacheType = INTERNET_FLAG_RESYNCHRONIZE
              This.nCachingType = INTERNET_FLAG_RESYNCHRONIZE
              fResult = .T.

      ENDCASE
				
      RETURN fResult								
   ENDPROC
		
   ****************************************************
   PROCEDURE GetCachingMethod
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      RETURN This.nCachingType		  
   ENDPROC
		 
   ****************************************************
   PROCEDURE GetFtpFile(lcRemoteFile, lcNewFile, llFailIfExists)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="llFailIfExists" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPFile>FTP_SERVICE::BeforeFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPFile>FTP_SERVICE::AfterFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>

*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult, lnFail
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lnFail=IIF(llFailIfExists,1,0)
		  	  	
         lcNewFile = lcNewFile + cNULL
         lcRemoteFile = lcRemoteFile + cNULL
		  	  
         =This.BeforeGetFtpFile(lcRemoteFile, lcNewFile, llFailIfExists)
         fResult = FtpGetFile(This.nConnect_Handle, @lcRemoteFile, @lcNewFile, lnFail, ;
                              FILE_ATTRIBUTE_NORMAL, FTP_TRANSFER_TYPE_BINARY + This.nCachingType, 0)
         =This.GetExtendedError()
         =This.AfterGetFtpFile(lcRemoteFile, lcNewFile, llFailIfExists,fResult)
		  	  	
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
		  	  	
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeGetFtpFile(lcRemoteFile, lcNewFile, llFailIfExists)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="llFailIfExists" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPFile>FTP_SERVICE::AfterFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFtpFile(lcRemoteFile, lcNewFile, llFailIfExists,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="llFailIfExists" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPFile>FTP_SERVICE::BeforeFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

	  	
   ****************************************************
   PROCEDURE PutFtpFile(lcRemoteFile, lclocalFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lclocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforePutFTPFile>FTP_SERVICE::BeforePutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterPutFTPFile>FTP_SERVICE::AfterPutFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL
         lcLocalFile = lcLocalFile + cNULL
		  	  	  	  	
         =This.BeforePutFtpFile(lcRemoteFile, lclocalFile)
         fResult = FtpPutFile(This.nConnect_Handle, @lcLocalFile, @lcRemoteFile, ;
                              FTP_TRANSFER_TYPE_BINARY, 0)
         =This.GetExtendedError()
         =This.AfterPutFtpFile(lcRemoteFile, lclocalFile,fResult)

         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
	  	    	
	  	   RETURN  fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforePutFtpFile(lcRemoteFile, lclocalFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lclocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterPutFTPFile>FTP_SERVICE::AfterPutFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterPutFtpFile(lcRemoteFile, lclocalFile,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lclocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforePutFTPFile>FTP_SERVICE::BeforePutFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC


   ****************************************************
   PROCEDURE WriteFtpFile(lcRemoteFile, lcLocalFile,liData)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeWriteFTPFile>FTP_SERVICE::BeforeWriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterWriteFTPFile>FTP_SERVICE::AfterWriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtWriteFTPFile>FTP_SERVICE::AtWriteFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult,lihFTP,lcData,liData,liWrite,lihFile,llFast,lcAll
      LOCAL ARRAY laFile(1)
      IF ADIR(laFile,lcLocalFile,"RSHA")=0
         RETURN .F.
      ENDIF

      llFast=VAL(STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0",""))>5 AND laFile(1,2)<=15000000

      IF llFast
         lcAll=FILETOSTR(lcLocalFile)
      ELSE
         lihFile=FOPEN(lcLocalFile,2)
      ENDIF

      IF This.OpenFtpConnection(This.cStartupFolder) AND IIF(llFast,.T.,lihFile>0)    && Open an FTP Handle
         liData=IIF(PCOUNT()<3,100,liData)
         lcRemoteFile = lcRemoteFile + cNULL
         lcLocalFile = lcLocalFile

         =This.BeforeWriteFtpFile(lcRemoteFile, lcLocalFile,liData)
         STORE FtpOpenFile(This.nConnect_Handle, @lcRemoteFile, GENERIC_WRITE, ;
                           FTP_TRANSFER_TYPE_BINARY, 0) TO fResult,lihFTP

         =This.GetExtendedError()
         IF fResult #0 && OK, FTP file is openned
            DO CASE
               CASE laFile(1,2)=0
                    lcData=""
                    liData=LEN(lcData)

                    liWrite=0
                    fResult = InternetWriteFile(lihFTP, @lcData, liData, @liWrite)
                    =This.GetExtendedError()
                    =This.AtWriteFtpFile(@lcRemoteFile,@lcLocalFile,1,@lcData,liData,liWrite,fResult)
                    IF fResult#1
                       EXIT
                    ENDIF
         
               CASE llFast
                    lii=1
               
                    DO WHILE lii<LEN(lcAll)
                       lcData=SUBST(lcAll,lii,liData)
                       liData=LEN(lcData)

                       liWrite=0
                       fResult = InternetWriteFile(lihFTP, @lcData, liData, @liWrite)
                       =This.GetExtendedError()
                       =This.AtWriteFtpFile(@lcRemoteFile,@lcLocalFile,lii,@lcData,liData,liWrite,fResult)
                       IF fResult#1
                          EXIT
                       ENDIF
                       lii=lii+liData
                    ENDDO

               OTHERWISE
                    DO WHILE !FEOF(lihFile)
                       lcData=FREAD(lihFile,liData)
                       liData=LEN(lcData)

                       liWrite=0
                       fResult = InternetWriteFile(lihFTP, @lcData, liData, @liWrite)
                       =This.GetExtendedError()
                       =This.AtWriteFtpFile(@lcRemoteFile,@lcLocalFile,lii,@lcData,liData,liWrite,fResult)
                       IF fResult#1
                          EXIT
                       ENDIF
                    ENDDO
            ENDCASE

            =InternetCloseHandle(lihFTP)
         ENDIF

         =This.AfterWriteFtpFile(lcRemoteFile, lcLocalFile,liData,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
         RETURN  fResult = 1
      ENDIF
      =IIF(lihFile>0 AND !llFast,FCLOSE(lihFile),.T.)
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeWriteFtpFile(lcRemoteFile, lcLocalFile,liData)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtWriteFTPFile>FTP_SERVICE::AtWriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterWriteFTPFile>FTP_SERVICE::AfterWriteFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterWriteFtpFile(lcRemoteFile, lcLocalFile,liData,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeWriteFTPFile>FTP_SERVICE::BeforeWriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtWriteFTPFile>FTP_SERVICE::AtWriteFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AtWriteFtpFile(lcRemoteFile, lcLocalFile,liStart,lcData,liData,liWrite,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liStart" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcData" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liWrite" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeWriteFTPFile>FTP_SERVICE::BeforeWriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterWriteFTPFile>FTP_SERVICE::AfterWriteFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC



   ****************************************************
   PROCEDURE ReadFtpFile(lcRemoteFile, lcLocalFile,liData)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeReadFTPFile>FTP_SERVICE::BeforeReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterReadFTPFile>FTP_SERVICE::AfterReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtReadFTPFile>FTP_SERVICE::AtReadFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult,lihFTP,lcData,liData,liRead,lihFile,llFast,lcAll,llAppend
      llFast=VAL(STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0",""))>6

      IF !llFast
         lihFile=FCREATE(lcLocalFile,0)
      ENDIF

      IF This.OpenFtpConnection(This.cStartupFolder) AND IIF(llFast,.T.,lihFile>0)    && Open an FTP Handle
         liData=IIF(PCOUNT()<3,100,liData)
         lcRemoteFile = lcRemoteFile + cNULL

         =This.BeforeReadFtpFile(lcRemoteFile, lcLocalFile,liData)
         STORE FtpOpenFile(This.nConnect_Handle, @lcRemoteFile, GENERIC_READ, ;
                           FTP_TRANSFER_TYPE_BINARY, 0) TO fResult,lihFTP

         =This.GetExtendedError()
         IF fResult #0 && OK, FTP file is openned
            lii=0
            lcAll=""
            liRead=1
         
            DO WHILE liRead>0
               liRead=0
               lcData=SPACE(liData)
               fResult = InternetReadFile(lihFTP, @lcData, liData, @liRead)
               =This.GetExtendedError()
               =This.AtReadFtpFile(@lcRemoteFile,@lcLocalFile,lii,@lcData,liData,liRead,fResult)

               IF llFast
                  IF liRead>0
                     IF LEN(lcAll)>15000000
                        =STRTOFILE(lcAll,lcLocalFile,llAppend)
                        llAppend=.T.
                        lcAll=""
                     ENDIF
                     lcAll=lcAll+LEFT(lcData,liRead)
                  ENDIF
               ELSE
                  IF liRead>0
                     =FWRITE(lihFile,LEFT(lcData,liRead),liRead)
                  ENDIF
               ENDIF
               IF fResult#1
                  EXIT
               ENDIF
               lii=lii+liRead
            ENDDO

            IF llFast
               IF LEN(lcAll)>0
                  =STRTOFILE(lcAll,lcLocalFile,llAppend)
               ENDIF
            ENDIF
            =InternetCloseHandle(lihFTP)
         ENDIF

         =This.AfterReadFtpFile(lcRemoteFile, lcLocalFile,liData,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
         RETURN  fResult = 1
      ENDIF
      =IIF(lihFile>0 AND !llFast,FCLOSE(lihFile),.T.)
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeReadFtpFile(lcRemoteFile, lcLocalFile,liData)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtReadFTPFile>FTP_SERVICE::AtReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterReadFTPFile>FTP_SERVICE::AfterReadFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterReadFtpFile(lcRemoteFile, lcLocalFile,liData,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeReadFTPFile>FTP_SERVICE::BeforeReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AtReadFTPFile>FTP_SERVICE::AtReadFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AtReadFtpFile(lcRemoteFile, lcLocalFile,liStart,lcData,liData,liRead,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcLocalFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liStart" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcData" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liData" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liRead" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeReadFTPFile>FTP_SERVICE::BeforeReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterReadFTPFile>FTP_SERVICE::AfterReadFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE FtpCommand(lcCommand, liFlags, liContext)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcCommand" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liFlags" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liContext" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeFTPCommand>FTP_SERVICE::BeforeFTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterFTPCommand>FTP_SERVICE::AfterFTPCommand()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult,lii
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         liFlags=IIF(PCOUNT<2,FTP_TRANSFER_TYPE_BINARY,liFlags)
         liContext=IIF(PCOUNT<3,0,liContext)
         lii=0

         lcCommand = lcCommand + cNULL
         =This.BeforeFtpCommand(lcCommand, liFlags, liContext)
         fResult = FtpCommand(This.nConnect_Handle, 0, liFlags, @lcCommand,liContext,@lii)

         =This.GetExtendedError()
         =This.AfterFtpCommand(lcCommand, liFlags, liContext,fResult)

         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
               
           RETURN  fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeFtpCommand(lcCommand, liFlags, liContext)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcCommand" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liFlags" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liContext" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterFTPCommand>FTP_SERVICE::AfterFTPCommand()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterFtpCommand(lcCommand, liFlags, liContext,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcCommand" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liFlags" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="liContext" type="Integer" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeFTPCommand>FTP_SERVICE::BeforeFTPCommand()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC




	  	
   ****************************************************
   PROCEDURE DeleteFtpFile(lcRemoteFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeDeleteFTPFile>FTP_SERVICE::BeforeDeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterDeleteFTPFile>FTP_SERVICE::AfterDeleteFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL
		  	  		  	  	  	  	
         =This.BeforeDeleteFtpFile(lcRemoteFile)
         fResult = FtpDeleteFile(This.nConnect_Handle, @lcRemoteFile)
         This.GetExtendedError()
         =This.AfterDeleteFtpFile(lcRemoteFile,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
	  	RETURN .F.    	  	  	
   ENDPROC

   ****************************************************
   PROCEDURE BeforeDeleteFtpFile(lcRemoteFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterDeleteFTPFile>FTP_SERVICE::AfterDeleteFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterDeleteFtpFile(lcRemoteFile,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcRemoteFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeDeleteFTPFile>FTP_SERVICE::BeforeDeleteFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
		
		
   ****************************************************
   PROCEDURE RenameFtpFile(lcOldFile, lcNewFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcOldFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeRenameFTPFile>FTP_SERVICE::BeforeRenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterRenameFTPFile>FTP_SERVICE::AfterRenameFTPFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lcOldFile = lcOldFile + cNULL
         lcNewFile = lcNewFile + cNULL
		  	  	  	  	
         =This.BeforeRenameFtpFile(lcOldFile, lcNewFile)
         fResult = FtpRenameFile(This.nConnect_Handle, @lcOldFile, @lcNewFile)
         =This.GetExtendedError()
         =This.AfterRenameFtpFile(lcOldFile, lcNewFile,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
		  	RETURN fResult = 1
      ENDIF
      RETURN .F.    	  	  	
   ENDPROC
		

   ****************************************************
   PROCEDURE BeforeRenameFtpFile(lcOldFile, lcNewFile)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcOldFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterRenameFTPFile>FTP_SERVICE::AfterRenameFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterRenameFtpFile(lcOldFile, lcNewFile,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcOldFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcNewFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeRenameFTPFile>FTP_SERVICE::BeforeRenameFTPFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
		
		
   ****************************************************
   PROCEDURE CreateFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeCreateFTPDirectory>FTP_SERVICE::BeforeCreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterCreateFTPDirectory>FTP_SERVICE::AfterCreateFTPDirectory()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle  	   		
         lcNewDir = lcNewDir + cNULL
		  	   	  	   		  	   	 
         =This.BeforeCreateFtpDirectory(lcNewDir)
         fResult = FtpCreateDirectory(This.nConnect_Handle, @lcNewDir)
         =This.GetExtendedError()
         =This.AfterCreateFtpDirectory(lcNewDir,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
		  	 	
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeCreateFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterCreateFTPDirectory>FTP_SERVICE::AfterCreateFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterCreateFtpDirectory(lcNewDir,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeCreateFTPDirectory>FTP_SERVICE::BeforeCreateFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

	  	
   ****************************************************
   PROCEDURE RemoveFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeRemoveFTPDirectory>FTP_SERVICE::BeforeRemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterRemoveFTPDirectory>FTP_SERVICE::AfterRemoveFTPDirectory()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle  	   		  
         lcNewDir = lcNewDir + cNULL
		  	   	  	   		  	   	 
         =This.BeforeRemoveFtpDirectory(lcNewDir)
         fResult = FtpRemoveDirectory(This.nConnect_Handle, @lcNewDir)
         =This.GetExtendedError()
         =This.AfterRemoveFtpDirectory(lcNewDir,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
		  	 	
         RETURN fResult = 1
      ENDIF
      RETURN .F. 
   ENDPROC


   ****************************************************
   PROCEDURE BeforeRemoveFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterRemoveFTPDirectory>FTP_SERVICE::AfterRemoveFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterRemoveFtpDirectory(lcNewDir,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeRemoveFTPDirectory>FTP_SERVICE::BeforeRemoveFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
			 
   ****************************************************
   PROCEDURE ChangeFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeChangeFTPDirectory>FTP_SERVICE::BeforeChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterChangeFTPDirectory>FTP_SERVICE::AfterChangeFTPDirectory()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult, lcTempDir, llResult
	  	   	  	   		  
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle 	   		  
         llResult = .F.	 
	  	   	  	   		  	   
         lcNewDir = lcNewDir + cNULL  
         lcTempDir = SPACE(MAX_PATH)	   		  	   	
		  	   	  	   		  	   	 
         =This.BeforeChangeFtpDirectory(lcNewDir)
         fResult = FtpSetCurrentDirectory(This.nConnect_Handle, @lcNewDir)
         =This.GetExtendedError()
		  	 		  	 	
         IF fResult = 1
            fResult = FtpGetCurrentDirectory(This.nConnect_Handle, @lcTempDir, MAX_PATH)
            =This.GetExtendedError()
		  	 		  	 		
            IF fResult = 1
               This.cCurrentDir = lcTempDir
               llResult = .T.
            ENDIF
         ENDIF
         =This.AfterChangeFtpDirectory(lcNewDir,fResult)
		  	 	
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
         RETURN llResult
      ENDIF	  	 
      RETURN .F. 		  	 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeChangeFtpDirectory(lcNewDir)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterChangeFTPDirectory>FTP_SERVICE::AfterChangeFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterChangeFtpDirectory(lcNewDir,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcNewDir" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeChangeFTPDirectory>FTP_SERVICE::BeforeChangeFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
	  	
   ****************************************************
   PROCEDURE GetFtpDirectory(lcDirectory)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDirectory" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPDirectory>FTP_SERVICE::BeforeGetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPDirectory>FTP_SERVICE::AfterGetFTPDirectory()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL fResult, lcTempDir
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lcTempDir = SPACE(MAX_PATH)
         =This.BeforeGetFtpDirectory(lcDirectory)
         fResult = FtpGetCurrentDirectory(This.nConnect_Handle, @lcTempDir, MAX_PATH)
         =This.GetExtendedError()
         lcDirectory = LEFT(lcTempDir, AT(cNULL, lcTempDir) - 1)
         =This.AfterGetFtpDirectory(lcDirectory,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC

   ****************************************************
   PROCEDURE BeforeGetFtpDirectory(lcDirectory)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDirectory" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPDirectory>FTP_SERVICE::AfterGetFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFtpDirectory(lcDirectory,fResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcDirectory" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="fResult" type="" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPDirectory>FTP_SERVICE::BeforeGetFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC
		
				
   ****************************************************
   PROCEDURE GetFtpDirectoryArray(laDirectory, lcMask)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="laDirectory" type="Array" byref="0" dir="Input/Output" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcMask" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPDirectoryArray>FTP_SERVICE::BeforeGetFTPDirectoryArray()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPDirectoryArray>FTP_SERVICE::AfterGetFTPDirectoryArray()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="CrackFile>FTP_SERVICE::CrackFile()</see>

*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPFile>FTP_SERVICE::GetFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ReadFTPFile>FTP_SERVICE::ReadFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="PutFTPFile>FTP_SERVICE::PutFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="WriteFTPFile>FTP_SERVICE::WriteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="FTPCommand>FTP_SERVICE::FTPCommand()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="DeleteFTPFile>FTP_SERVICE::DeleteFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RenameFTPFile>FTP_SERVICE::RenameFTPFile()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CreateFTPDirectory>FTP_SERVICE::CreateFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="RemoveFTPDirectory>FTP_SERVICE::RemoveFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="ChangeFTPDirectory>FTP_SERVICE::ChangeFTPDirectory()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectory>FTP_SERVICE::GetFTPDirectory()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL cStruct, llResult, lnCount, fResult, lffHandle
      IF This.OpenFtpConnection(This.cStartupFolder)     && Open an FTP Handle
         lcMask = lcMask + cNULL
		      
         * Dimension the array to store the directory
         * [x, 1] = FileName
         * [x, 2] = Alternate FileName
         * [x, 3] = File Size
         * [x, 4] = File Create Date
         * [x, 5] = File Last Access Time
         * [x, 6] = File Last Write Time
         * [x, 7] = File Attributes
         DIMENSION laDirectory [1, 7]
         laDirectory [1, 1] = .F.
		    	      	
         * This is for a FoxPro Quirk.
         lcStruct = SPACE(319)   && Allocate space for the returned structure
		      	
         =This.BeforeGetFtpDirectoryArray(@laDirectory, lcMask)
         * Get the first file or find out if 
         lffHandle = FtpFindFirstFile(This.nConnect_Handle, @lcMask, @lcStruct, 0, 0)
         This.GetExtendedError()
		      	
         IF lffHandle = 0 OR This.nResult_Code = ERROR_NO_MORE_FILES
            =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
            RETURN .F.
         ENDIF
		      
         * Parse out First File Information
         =This.CrackFile(lcStruct, @laDirectory)
		      	
         llResult = 1
         DO WHILE This.nResult_Code != ERROR_NO_MORE_FILES AND llResult != 0
            lcStruct = SPACE(319)
            * Get next files
            llResult = InternetFindNextFile(lffHandle, @lcStruct)
            =This.GetExtendedError()
			    		
            * If we got good information, go ahead and parse it
            IF This.nResult_Code != ERROR_NO_MORE_FILES AND llResult != 0
               =This.CrackFile(lcStruct, @laDirectory)
            ENDIF
         ENDDO
         =This.AfterGetFtpDirectoryArray(laDirectory, lcMask,llResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFtpConnection())   && Close FTP Handle
      ELSE
         RETURN .F.     && Unable to get FTP Connection	
      ENDIF
      RETURN .T.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeGetFtpDirectoryArray(laDirectory, lcMask)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="laDirectory" type="Array" byref="0" dir="Input/Output" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcMask" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="AfterGetFTPDirectoryArray>FTP_SERVICE::AfterGetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFtpDirectoryArray(laDirectory, lcMask,llResult)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="laDirectory" type="Array" byref="0" dir="Input/Output" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="lcMask" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="llResult" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="BeforeGetFTPDirectoryArray>FTP_SERVICE::BeforeGetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
   ENDPROC

		
   ****************************************************
   PROCEDURE GetErrorCode(llShowMessage)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="llShowMessage" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcMessage
      IF llShowMessage = .T.
         * Build Error Message Here
         lcMessage = "Error (" + ALLTRIM(STR(This.nResult_Code)) + ")  -  " + ;
                     This.GetErrorText(This.nResult_Code)
         IF !EMPTY(This.cExtended_Message)
            lcMessage = lcMessage + CHR(13) + CHR(13) + "Extended Error Info - (" + ;
                        ALLTRIM(STR(This.nExtended_Result)) + ;
                        ") - " + This.cExtended_Message
         ENDIF
         =MESSAGEBOX(lcMessage, 48, "FTP Error Message")
      ENDIF
      RETURN This.nResult_Code
   ENDPROC
	 	
	 	
   ****************************************************
   PROCEDURE GetExtendedErrorCode
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      RETURN This.nExtended_Result
   ENDPROC
	 	
	 	
   ****************************************************
   PROCEDURE GetExtendedErrorMsg
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      RETURN This.cExtended_Message
   ENDPROC
	 	
	 	
   ****************************************************
   PROCEDURE CrackFile(lcString, laDirectory)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcString" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="laDirectory" type="Array" byref="0" dir="Input/Output" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="CrackDate>FTP_SERVICE::CrackDate()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="CrackAttributes>FTP_SERVICE::CrackAttributes()</see>
*!*    <see loca="" class="FTP_SERVICE" pem="GetFTPDirectoryArray>FTP_SERVICE::GetFTPDirectoryArray()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcFileName, lcAlterName, lnSizeHigh, lnSizeLow, lnFileSize, ;
            lcAttributes, lnArrayLen, lcTimeBuff, ;
            ldCreateDate, ldAccessDate, ldWriteDate, laNewArray, lnResult
	      	
      IF TYPE('laDirectory[1, 1]') = 'L'	&& Array Has Not Been Filed      
         * Force Record size of 1
         DIMENSION laDirectory [1, 7]
      ELSE	
         * Expand Array
         DIMENSION laDirectory [ALEN(laDirectory, 1) + 1, 7]
      ENDIF
	        
      * Get new Array Position
      lnArrayLen = ALEN(laDirectory, 1)
          		       	      
      lcFileName = SUBSTR(lcString, 45, MAX_PATH)
      lcAlterName = RIGHT(lcString, 14)
	      	
      lcFileName = LEFT(lcFileName, AT(cNull, lcFileName) - 1)  && Copy out just the File Name Text
      lcAlterName = LEFT(lcAlterName, AT(cNull, lcAlterName) - 1)
	      	
      * Convert File Size DWORDs
      lnSizeHigh = (ASC(SUBSTR(lcString, 29, 1)) * BYTE_1) + ;
                   (ASC(SUBSTR(lcString, 30, 1)) * BYTE_2) + ;
                   (ASC(SUBSTR(lcString, 31, 1)) * BYTE_3) + ;
                   (ASC(SUBSTR(lcString, 32, 1)) * BYTE_4) 
	      				 
      lnSizeLow =  (ASC(SUBSTR(lcString, 33, 1)) * BYTE_1) + ;
                   (ASC(SUBSTR(lcString, 34, 1)) * BYTE_2) + ;
                   (ASC(SUBSTR(lcString, 35, 1)) * BYTE_3) + ;
                   (ASC(SUBSTR(lcString, 36, 1)) * BYTE_4) 
	      				 
      * Build File Size
      lnFileSize = (lnSizeHigh * MAXDWORD) + lnSizeLow
	      	
      * Convert File Date
	       
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 5, 8)
      ldCreateDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 13, 8)
      ldAccessDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 21, 8)
      ldWriteDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Attributes
      lcAttributes = This.CrackAttributes(LEFT(lcString, 4))
	        
      laDirectory[lnArrayLen, 1] = ALLTRIM(lcFileName)
      laDirectory[lnArrayLen, 2] = ALLTRIM(lcAlterName)
      laDirectory[lnArrayLen, 3] = lnFileSize
      laDirectory[lnArrayLen, 4] = ldCreateDate
      laDirectory[lnArrayLen, 5] = ldAccessDate
      laDirectory[lnArrayLen, 6] = ldWriteDate
      laDirectory[lnArrayLen, 7] = lcAttributes
  	 
      RETURN 
   ENDPROC
	    
   ****************************************************
   PROCEDURE CrackDate(lcOutBuffer)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcOutBuffer" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="CrackFile>FTP_SERVICE::CrackFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcInBuffer, ldDateTime, fResult, lcBuild, ;
            lnDay, lnMonth, lnYear, lnHour, lnMinute, lnSecond
		
      lcInBuffer = SPACE(16)
		
      fResult = FileTimeToSystemTime(@lcOutBuffer, @lcInBuffer)
      This.GetExtendedError()
			
      IF fResult = 0   && Failed
         ldDateTime = {^1901/01/01 00:00:01}   && Default Time
         RETURN ldDateTime
      ENDIF
			
      lnYear = ASC(SUBSTR(lcInBuffer, 1, 1)) + (ASC(SUBSTR(lcInBuffer, 2, 1)) * BYTE_2)
      lnMonth = ASC(SUBSTR(lcInBuffer, 3, 1)) + (ASC(SUBSTR(lcInBuffer, 4, 1)) * BYTE_2)
      lnDay = ASC(SUBSTR(lcInBuffer, 7, 1)) + (ASC(SUBSTR(lcInBuffer, 8, 1)) * BYTE_2)
      lnHour = ASC(SUBSTR(lcInBuffer, 9, 1)) + (ASC(SUBSTR(lcInBuffer, 10, 1)) * BYTE_2)
      lnMinute = ASC(SUBSTR(lcInBuffer, 11, 1)) + (ASC(SUBSTR(lcInBuffer, 12, 1)) * BYTE_2)
      lnSecond = ASC(SUBSTR(lcInBuffer, 13, 1)) + (ASC(SUBSTR(lcInBuffer, 13, 1)) * BYTE_2)
			
      lcBuild = "^" + ALLTRIM(STR(lnYear)) + '/' + ALLTRIM(STR(lnMonth)) + '/' + ALLTRIM(STR(lnDay)) + ' ' + ;
                ALLTRIM(STR(lnHour)) + ':' + ALLTRIM(STR(lnMinute)) + ':' + ALLTRIM(STR(lnSecond))
				      
      ldDateTime = {&lcBuild}
      RETURN ldDateTime
   ENDPROC
		  
   ****************************************************
   PROCEDURE CrackAttributes(lcBuffer)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lcBuffer" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*    <see loca="" class="FTP_SERVICE" pem="CrackFile>FTP_SERVICE::CrackFile()</see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcAttributes, lnValue
      lcAttributes = ''
	 		 		
      lnValue = (ASC(SUBSTR(lcBuffer, 1, 1)) * BYTE_1) + ;
                (ASC(SUBSTR(lcBuffer, 2, 1)) * BYTE_2) + ;
                (ASC(SUBSTR(lcBuffer, 3, 1)) * BYTE_3) + ;
                (ASC(SUBSTR(lcBuffer, 4, 1)) * BYTE_4) 
					  
      DO CASE
         CASE BITTEST(lnValue, BIT_ATTRIBUTE_READONLY) 
              lcAttributes = lcAttributes + 'R'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_HIDDEN) 
              lcAttributes = lcAttributes + 'H'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_SYSTEM) 
              lcAttributes = lcAttributes + 'S'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_DIRECTORY) 
              lcAttributes = lcAttributes + 'D'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_ARCHIVE) 
              lcAttributes = lcAttributes + 'A'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_NORMAL) 
              lcAttributes = lcAttributes + 'N'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_TEMPORARY) 
              lcAttributes = lcAttributes + 'T'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_COMPRESSED) 
              lcAttributes = lcAttributes + 'C'
   
         CASE BITTEST(lnValue, BIT_ATTRIBUTE_OFFLINE) 
              lcAttributes = lcAttributes + 'O'
      ENDCASE
						
      RETURN lcAttributes
   ENDPROC
		
   ****************************************************
   PROCEDURE GetExtendedError
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcMessage, lnError, lcBuffer
      This.nResult_Code = GetLastError()
	        
      lnError = 0
      lcBuffer = SPACE(MAX_PATH)
	        
      InternetGetLastResponseInfo(lnError, @lcBuffer, MAX_PATH)
		    
      This.nExtended_Result = lnError
      This.cExtended_Message = LEFT(lcBuffer, AT(cNULL, lcBuffer) - 1)
      RETURN 
   ENDPROC
				
   ****************************************************
   PROCEDURE GetErrorText(lnError)
*!*	<pdm>
*!*	<!-- <descr></descr> -->
*!*	<params name="lnError" type="Numeric" byref="0" dir="" inb="0" outb="0">
*!*	<short></short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	<comment>
*!*	</comment>
*!*	<copyright>&copy;24.11.2005 MJ</copyright>
*!*	</pdm> 
      LOCAL lcMessage
      DO CASE
         CASE lnError =  ERROR_INTERNET_OUT_OF_HANDLES                
              lcMessage = "ERROR_INTERNET_OUT_OF_HANDLES"

         CASE lnError =  ERROR_INTERNET_TIMEOUT                       
              lcMessage = "ERROR_INTERNET_TIMEOUT"

         CASE lnError =  ERROR_INTERNET_EXTENDED_ERROR                
              lcMessage = "ERROR_INTERNET_EXTENDED_ERROR"

         CASE lnError =  ERROR_INTERNET_INTERNAL_ERROR                
              lcMessage = "ERROR_INTERNET_INTERNAL_ERROR"

         CASE lnError =  ERROR_INTERNET_INVALID_URL                   
              lcMessage = "ERROR_INTERNET_INVALID_URL"

         CASE lnError =  ERROR_INTERNET_UNRECOGNIZED_SCHEME           
              lcMessage = "ERROR_INTERNET_UNRECOGNIZED_SCHEME"

         CASE lnError =  ERROR_INTERNET_NAME_NOT_RESOLVED             
              lcMessage = "ERROR_INTERNET_NAME_NOT_RESOLVED"

         CASE lnError =  ERROR_INTERNET_PROTOCOL_NOT_FOUND            
              lcMessage = "ERROR_INTERNET_PROTOCOL_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_INVALID_OPTION                
              lcMessage = "ERROR_INTERNET_INVALID_OPTION"

         CASE lnError =  ERROR_INTERNET_BAD_OPTION_LENGTH             
              lcMessage = "ERROR_INTERNET_BAD_OPTION_LENGTH"

         CASE lnError =  ERROR_INTERNET_OPTION_NOT_SETTABLE           
              lcMessage = "ERROR_INTERNET_OPTION_NOT_SETTABLE"

         CASE lnError =  ERROR_INTERNET_SHUTDOWN                      
              lcMessage = "ERROR_INTERNET_SHUTDOWN"

         CASE lnError =  ERROR_INTERNET_INCORRECT_USER_NAME           
              lcMessage = "ERROR_INTERNET_INCORRECT_USER_NAME"

         CASE lnError =  ERROR_INTERNET_INCORRECT_PASSWORD            
              lcMessage = "ERROR_INTERNET_INCORRECT_PASSWORD"

         CASE lnError =  ERROR_INTERNET_LOGIN_FAILURE                 
              lcMessage = "ERROR_INTERNET_LOGIN_FAILURE"

         CASE lnError =  ERROR_INTERNET_INVALID_OPERATION             
              lcMessage = "ERROR_INTERNET_INVALID_OPERATION"

         CASE lnError =  ERROR_INTERNET_OPERATION_CANCELLED           
              lcMessage = "ERROR_INTERNET_OPERATION_CANCELLED"

         CASE lnError =  ERROR_INTERNET_INCORRECT_HANDLE_TYPE         
              lcMessage = "ERROR_INTERNET_INCORRECT_HANDLE_TYPE"

         CASE lnError =  ERROR_INTERNET_INCORRECT_HANDLE_STATE        
              lcMessage = "ERROR_INTERNET_INCORRECT_HANDLE_STATE"

         CASE lnError =  ERROR_INTERNET_NOT_PROXY_REQUEST             
              lcMessage = "ERROR_INTERNET_NOT_PROXY_REQUEST"

         CASE lnError =  ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND      
              lcMessage = "ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_BAD_REGISTRY_PARAMETER        
              lcMessage = "ERROR_INTERNET_BAD_REGISTRY_PARAMETER"

         CASE lnError =  ERROR_INTERNET_NO_DIRECT_ACCESS              
              lcMessage = "ERROR_INTERNET_NO_DIRECT_ACCESS"

         CASE lnError =  ERROR_INTERNET_NO_CONTEXT                    
              lcMessage = "ERROR_INTERNET_NO_CONTEXT"

         CASE lnError =  ERROR_INTERNET_NO_CALLBACK                   
              lcMessage = "ERROR_INTERNET_NO_CALLBACK"

         CASE lnError =  ERROR_INTERNET_REQUEST_PENDING               
              lcMessage = "ERROR_INTERNET_REQUEST_PENDING"

         CASE lnError =  ERROR_INTERNET_INCORRECT_FORMAT              
              lcMessage = "ERROR_INTERNET_INCORRECT_FORMAT"

         CASE lnError =  ERROR_INTERNET_ITEM_NOT_FOUND                
              lcMessage = "ERROR_INTERNET_ITEM_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_CANNOT_CONNECT                
              lcMessage = "ERROR_INTERNET_CANNOT_CONNECT"

         CASE lnError =  ERROR_INTERNET_CONNECTION_ABORTED            
              lcMessage = "ERROR_INTERNET_CONNECTION_ABORTED"

         CASE lnError =  ERROR_INTERNET_CONNECTION_RESET              
              lcMessage = "ERROR_INTERNET_CONNECTION_RESET"

         CASE lnError =  ERROR_INTERNET_FORCE_RETRY                   
              lcMessage = "ERROR_INTERNET_FORCE_RETRY"

         CASE lnError =  ERROR_INTERNET_INVALID_PROXY_REQUEST         
              lcMessage = "ERROR_INTERNET_INVALID_PROXY_REQUEST"

         CASE lnError =  ERROR_INTERNET_NEED_UI                       
              lcMessage = "ERROR_INTERNET_NEED_UI"

         CASE lnError =  ERROR_INTERNET_HANDLE_EXISTS                 
              lcMessage = "ERROR_INTERNET_HANDLE_EXISTS"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_DATE_INVALID         
              lcMessage = "ERROR_INTERNET_SEC_CERT_DATE_INVALID"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_CN_INVALID           
              lcMessage = "ERROR_INTERNET_SEC_CERT_CN_INVALID"

         CASE lnError =  ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR        
              lcMessage = "ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR"

         CASE lnError =  ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR        
              lcMessage = "ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR"

         CASE lnError =  ERROR_INTERNET_MIXED_SECURITY                
              lcMessage = "ERROR_INTERNET_MIXED_SECURITY"

         CASE lnError =  ERROR_INTERNET_CHG_POST_IS_NON_SECURE        
              lcMessage = "ERROR_INTERNET_CHG_POST_IS_NON_SECURE"

         CASE lnError =  ERROR_INTERNET_POST_IS_NON_SECURE            
              lcMessage = "ERROR_INTERNET_POST_IS_NON_SECURE"

         CASE lnError =  ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED       
              lcMessage = "ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED"

         CASE lnError =  ERROR_INTERNET_INVALID_CA                    
              lcMessage = "ERROR_INTERNET_INVALID_CA"

         CASE lnError =  ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP         
              lcMessage = "ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP"

         CASE lnError =  ERROR_INTERNET_ASYNC_THREAD_FAILED           
              lcMessage = "ERROR_INTERNET_ASYNC_THREAD_FAILED"

         CASE lnError =  ERROR_INTERNET_REDIRECT_SCHEME_CHANGE        
              lcMessage = "ERROR_INTERNET_REDIRECT_SCHEME_CHANGE"

         CASE lnError =  ERROR_INTERNET_DIALOG_PENDING                
              lcMessage = "ERROR_INTERNET_DIALOG_PENDING"

         CASE lnError =  ERROR_INTERNET_RETRY_DIALOG                  
              lcMessage = "ERROR_INTERNET_RETRY_DIALOG"

         CASE lnError =  ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR       
              lcMessage = "ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR"

         CASE lnError =  ERROR_INTERNET_INSERT_CDROM                  
              lcMessage = "ERROR_INTERNET_INSERT_CDROM"

         CASE lnError =  FTP_TRANSFER_IN_PROGRESS            	     
              lcMessage = "FTP_TRANSFER_IN_PROGRESS"

         CASE lnError =  FTP_DROPPED                         	     
              lcMessage = "FTP_DROPPED"

         CASE lnError =  FTP_NO_PASSIVE_MODE                          
              lcMessage = "FTP_NO_PASSIVE_MODE"

         CASE lnError =  ERROR_INTERNET_SECURITY_CHANNEL_ERROR        
              lcMessage = "ERROR_INTERNET_SECURITY_CHANNEL_ERROR"

         CASE lnError =  ERROR_INTERNET_UNABLE_TO_CACHE_FILE          
              lcMessage = "ERROR_INTERNET_UNABLE_TO_CACHE_FILE"

         CASE lnError =  ERROR_INTERNET_TCPIP_NOT_INSTALLED           
              lcMessage = "ERROR_INTERNET_TCPIP_NOT_INSTALLED"

         CASE lnError =  ERROR_INTERNET_DISCONNECTED                  
              lcMessage = "ERROR_INTERNET_DISCONNECTED"

         CASE lnError =  ERROR_INTERNET_SERVER_UNREACHABLE            
              lcMessage = "ERROR_INTERNET_SERVER_UNREACHABLE"

         CASE lnError =  ERROR_INTERNET_PROXY_SERVER_UNREACHABLE      
              lcMessage = "ERROR_INTERNET_PROXY_SERVER_UNREACHABLE"

         CASE lnError =  ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT         
              lcMessage = "ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT"

         CASE lnError =  ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT     
              lcMessage = "ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT"

         CASE lnError =  ERROR_INTERNET_SEC_INVALID_CERT    		     
              lcMessage = "ERROR_INTERNET_SEC_INVALID_CERT"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_REVOKED    		     
              lcMessage = "ERROR_INTERNET_SEC_CERT_REVOKED"

         CASE lnError =  ERROR_NO_MORE_FILES
              lcMessage = "ERROR_NO_MORE_FILES"

         CASE lnError =  ERROR_INVALID_HANDLE
              lcMessage = "ERROR_INVALID_HANDLE"

         CASE lnError =  ERROR_FILE_NOT_FOUND
              lcMessage = "ERROR_FILE_NOT_FOUND"

         CASE lnError =  ERROR_PATH_NOT_FOUND
              lcMessage = "ERROR_PATH_NOT_FOUND"

         CASE lnError =  ERROR_ACCESS_DENIED
              lcMessage = "ERROR_ACCESS_DENIED"

         CASE lnError =  ERROR_FILE_EXISTS
              lcMessage = "ERROR_FILE_EXISTS"

         CASE lnError =  ERROR_INVALID_PARAMETER
              lcMessage = "ERROR_INVALID_PARAMETER"

         OTHERWISE	
              lcMessage = "Unknown Error Message"
      ENDCASE
      RETURN lcMessage
   ENDPROC	
ENDDEFINE